

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.masks &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.masks</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.masks</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>

<div class="viewcode-block" id="IndexMask"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMask">[docs]</a><span class="k">class</span> <span class="nc">IndexMask</span><span class="p">:</span>
  <span class="sd">&#39;&#39;&#39; Applied when creating a sliding window dataset&#39;&#39;&#39;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">masks</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="c1">#TODO: Document the &#39;name&#39; variable.</span>
    <span class="c1">#TODO: Examples is a mock up, replace with real ipython output.</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    masks : dict</span>
<span class="sd">        Dictionary containing np.arrays of np.arrays with relative indexes.</span>

<span class="sd">    name : string</span>
<span class="sd">        Name of the mask.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    None</span>

<span class="sd">    Examples</span>
<span class="sd">    -------</span>
<span class="sd">    &gt;&gt;&gt; maskDict = {&quot;var_1&quot;: [[-1, -2, -3]], &quot;var_2&quot;: [[-1, -2, -3], [-14, -15]]}</span>
<span class="sd">    &gt;&gt;&gt; mask = indexMask(maskDict)</span>
<span class="sd">    &gt;&gt;&gt; mask.masks</span>
<span class="sd">    {&quot;var_1&quot;: [[-1, -2, -3]], &quot;var_2&quot;: [[-1, -2, -3], [-14, -15]]}</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">masks</span> <span class="o">=</span> <span class="n">masks</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">cols</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span>

    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="bp">None</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;,&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">)</span>

<div class="viewcode-block" id="IndexMask.layout"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMask.layout">[docs]</a>  <span class="k">def</span> <span class="nf">layout</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">sig</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">col</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">:</span>
<span class="c1">#      print &quot;Inside layout, col = &quot;, col</span>
      <span class="n">masks</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">masks</span><span class="p">[</span><span class="n">col</span><span class="p">]</span>
<span class="c1">#      print &quot;Inside layout, masks = &quot;, masks</span>
      <span class="n">sig</span> <span class="o">+=</span> <span class="p">[(</span><span class="n">col</span><span class="p">,</span><span class="nb">min</span><span class="p">(</span><span class="n">mask</span><span class="p">),</span><span class="nb">max</span><span class="p">(</span><span class="n">mask</span><span class="p">),</span> <span class="nb">len</span><span class="p">(</span><span class="n">mask</span><span class="p">))</span> <span class="k">for</span> <span class="n">mask</span> <span class="ow">in</span> <span class="n">masks</span><span class="p">]</span>
<span class="c1">#    print &quot;Inside layout, sig = &quot;, sig</span>
    <span class="k">return</span> <span class="n">sig</span></div>

<div class="viewcode-block" id="IndexMask.apply"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMask.apply">[docs]</a>  <span class="k">def</span> <span class="nf">apply</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">index</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Returns a subset (pandas series.Series) per variable created by</span>
<span class="sd">    applying the mask on the original dataframe for the given index</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">for</span> <span class="n">col</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">cols</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">col</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="o">.</span><span class="n">values</span><span class="p">):</span>
        <span class="n">s</span> <span class="o">=</span> <span class="s2">&quot;Invalid dataframe, column &#39;</span><span class="si">%s</span><span class="s2">&#39; not found in </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">col</span><span class="p">,</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="o">.</span><span class="n">values</span><span class="p">)</span>
        <span class="k">print</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>

    <span class="n">sub_dfs</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">col</span><span class="p">,</span><span class="n">masks</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">iteritems</span><span class="p">():</span>
      <span class="n">indexed_mask</span> <span class="o">=</span> <span class="p">[</span><span class="n">l</span> <span class="k">for</span> <span class="n">sublist</span> <span class="ow">in</span> <span class="p">[</span><span class="n">index</span> <span class="o">+</span> <span class="n">mask</span> <span class="k">for</span> <span class="n">mask</span> <span class="ow">in</span> <span class="n">masks</span><span class="p">]</span> <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="n">sublist</span><span class="p">]</span>
      <span class="k">if</span> <span class="p">(</span><span class="nb">any</span><span class="p">(</span><span class="n">x</span> <span class="o">&gt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">indexed_mask</span><span class="p">)</span> <span class="ow">or</span> <span class="nb">any</span><span class="p">(</span><span class="n">x</span> <span class="o">&lt;</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">indexed_mask</span><span class="p">)):</span>
        <span class="k">raise</span> <span class="ne">IndexError</span><span class="p">(</span><span class="s2">&quot;Mask indices </span><span class="si">%s</span><span class="s2"> out of bounds for dataframe with range [0,</span><span class="si">%s</span><span class="s2">]&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">indexed_mask</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">)))</span>
      <span class="n">sub_dfs</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">([</span> <span class="n">df</span><span class="o">.</span><span class="n">iloc</span><span class="p">[(</span><span class="n">index</span> <span class="o">+</span> <span class="n">mask</span><span class="p">)][</span><span class="n">col</span><span class="p">]</span> <span class="k">for</span> <span class="n">mask</span> <span class="ow">in</span> <span class="n">masks</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">sub_dfs</span></div>

<div class="viewcode-block" id="IndexMask.apply_serialize"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMask.apply_serialize">[docs]</a>  <span class="k">def</span> <span class="nf">apply_serialize</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">index</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Returns a serialized ([index], [values]) representation of the</span>
<span class="sd">    masked dataframe &quot;&quot;&quot;</span>

    <span class="n">sub_dfs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">apply</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">index</span><span class="p">)</span>
    <span class="n">keys</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">sub_dfs</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span>

    <span class="n">serialized_index</span> <span class="o">=</span> <span class="p">[</span><span class="n">sub_dfs</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">values</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">]</span>
    <span class="n">serialized_index</span> <span class="o">=</span> <span class="p">[</span><span class="n">l</span> <span class="k">for</span> <span class="n">sublist</span> <span class="ow">in</span> <span class="n">serialized_index</span> <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="n">sublist</span><span class="p">]</span> <span class="c1"># Flatten</span>

    <span class="n">serialized_values</span> <span class="o">=</span> <span class="p">[</span><span class="n">sub_dfs</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">]</span>
    <span class="n">serialized_values</span> <span class="o">=</span> <span class="p">[</span><span class="n">l</span> <span class="k">for</span> <span class="n">sublist</span> <span class="ow">in</span> <span class="n">serialized_values</span> <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="n">sublist</span><span class="p">]</span> <span class="c1"># Flatten</span>

    <span class="k">return</span> <span class="p">(</span><span class="n">serialized_index</span><span class="p">,</span> <span class="n">serialized_values</span><span class="p">)</span></div>

  <span class="k">def</span> <span class="nf">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">return</span> <span class="nb">sum</span><span class="p">([</span><span class="n">x</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">layout</span><span class="p">()])</span>

  <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">return</span> <span class="s1">&#39;</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">layout</span><span class="p">()</span>
    <span class="n">s</span> <span class="o">=</span> <span class="s1">u&#39;Name: </span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span>
    <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">el</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">layout</span><span class="p">()):</span>
      <span class="n">s</span> <span class="o">+=</span> <span class="s2">u&quot;&quot;&quot;</span>
<span class="s2">      |Pos :{0:&gt;5}</span>
<span class="s2">      |Column :{1:&gt;5}</span>
<span class="s2">      |T_Min  :{2:&gt;5}</span>
<span class="s2">      |T_Max  :{3:&gt;5}</span>
<span class="s2">      |Length :{4:&gt;5}</span>
<span class="s2">      &quot;&quot;&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">,</span><span class="n">el</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span><span class="n">el</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="n">el</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span><span class="n">el</span><span class="p">[</span><span class="mi">3</span><span class="p">])</span>
    <span class="k">return</span> <span class="n">s</span></div>

<span class="kn">import</span> <span class="nn">unittest</span>
<div class="viewcode-block" id="IndexMaskTest"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMaskTest">[docs]</a><span class="k">class</span> <span class="nc">IndexMaskTest</span><span class="p">(</span><span class="n">unittest</span><span class="o">.</span><span class="n">TestCase</span><span class="p">):</span>
  <span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>
  <span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>

  <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">({</span><span class="s1">&#39;Total_RV&#39;</span><span class="p">:</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1000</span><span class="p">),</span> <span class="s1">&#39;Total_RN&#39;</span><span class="p">:</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1000</span><span class="p">),</span> <span class="s1">&#39;Restaurant&#39;</span><span class="p">:</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1000</span><span class="p">)})</span>

  <span class="n">start_date</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="s1">&#39;2000-01-01&#39;</span><span class="p">,</span> <span class="s1">&#39;%Y-%m-</span><span class="si">%d</span><span class="s1">&#39;</span><span class="p">)</span>
  <span class="n">df</span><span class="o">.</span><span class="n">index</span> <span class="o">=</span> <span class="p">[</span><span class="n">start_date</span> <span class="o">+</span> <span class="n">timedelta</span><span class="p">(</span><span class="n">days</span><span class="o">=</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1000</span><span class="p">)]</span>

  <span class="n">targets</span> <span class="o">=</span> <span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">)</span> <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="p">[[</span><span class="mi">6</span><span class="p">,</span><span class="mi">13</span><span class="p">,</span><span class="mi">20</span><span class="p">,</span><span class="mi">27</span><span class="p">,</span><span class="mi">34</span><span class="p">,</span><span class="mi">41</span><span class="p">]]]</span>
  <span class="n">inputs</span>  <span class="o">=</span> <span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">)</span> <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="p">[[</span><span class="mi">0</span><span class="p">,</span><span class="o">-</span><span class="mi">6</span><span class="p">,</span><span class="o">-</span><span class="mi">13</span><span class="p">,</span><span class="o">-</span><span class="mi">20</span><span class="p">,</span><span class="o">-</span><span class="mi">27</span><span class="p">,</span><span class="o">-</span><span class="mi">34</span><span class="p">,</span><span class="o">-</span><span class="mi">41</span><span class="p">],[</span><span class="o">-</span><span class="mi">365</span><span class="p">]]]</span>

  <span class="n">target_mask</span> <span class="o">=</span> <span class="n">IndexMask</span><span class="p">({</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">:</span><span class="n">targets</span><span class="p">})</span>
  <span class="n">input_mask</span> <span class="o">=</span> <span class="n">IndexMask</span><span class="p">({</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">:</span><span class="n">inputs</span><span class="p">,</span> <span class="s1">&#39;Total_RN&#39;</span><span class="p">:</span><span class="n">inputs</span><span class="p">})</span>

<div class="viewcode-block" id="IndexMaskTest.test_apply"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMaskTest.test_apply">[docs]</a>  <span class="k">def</span> <span class="nf">test_apply</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">applied_targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span><span class="o">.</span><span class="n">apply</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
    <span class="n">applied_inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span><span class="o">.</span><span class="n">apply</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="mi">365</span><span class="p">)</span>

    <span class="n">expected_targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="o">.</span><span class="n">iloc</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>
    <span class="n">expected_inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="o">.</span><span class="n">iloc</span><span class="p">[(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="mi">365</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span> <span class="o">+</span> <span class="p">[</span><span class="mi">0</span><span class="p">]]</span>

    <span class="n">first</span> <span class="o">=</span> <span class="n">applied_targets</span><span class="p">[</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">equals</span><span class="p">(</span><span class="n">expected_targets</span><span class="p">[</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">])</span>
    <span class="n">second</span> <span class="o">=</span> <span class="n">applied_inputs</span><span class="p">[</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">equals</span><span class="p">(</span><span class="n">expected_inputs</span><span class="p">[</span><span class="s1">&#39;Restaurant&#39;</span><span class="p">])</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">first</span> <span class="ow">and</span> <span class="n">second</span><span class="p">)</span></div>

<div class="viewcode-block" id="IndexMaskTest.test_serialized"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.masks.IndexMaskTest.test_serialized">[docs]</a>  <span class="k">def</span> <span class="nf">test_serialized</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span><span class="o">.</span><span class="n">apply_serialize</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
    <span class="n">inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span><span class="o">.</span><span class="n">apply_serialize</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="mi">365</span><span class="p">)</span>

    <span class="n">first</span> <span class="o">=</span> <span class="n">targets</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="p">[</span><span class="mi">6</span><span class="p">,</span> <span class="mi">13</span><span class="p">,</span> <span class="mi">20</span><span class="p">,</span> <span class="mi">27</span><span class="p">,</span> <span class="mi">34</span><span class="p">,</span> <span class="mi">41</span><span class="p">]</span>
    <span class="n">second</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="p">[</span><span class="mi">365</span><span class="p">,</span> <span class="mi">359</span><span class="p">,</span> <span class="mi">352</span><span class="p">,</span> <span class="mi">345</span><span class="p">,</span> <span class="mi">338</span><span class="p">,</span> <span class="mi">331</span><span class="p">,</span> <span class="mi">324</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">365</span><span class="p">,</span> <span class="mi">359</span><span class="p">,</span> <span class="mi">352</span><span class="p">,</span> <span class="mi">345</span><span class="p">,</span> <span class="mi">338</span><span class="p">,</span> <span class="mi">331</span><span class="p">,</span> <span class="mi">324</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">first</span> <span class="ow">and</span> <span class="n">second</span><span class="p">)</span></div></div>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
  <span class="n">unittest</span><span class="o">.</span><span class="n">main</span><span class="p">()</span>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>